/*
Rjesenje zadatka 2.3.7 uz ispis rastava (pogledati prije
rjesenje zadatka 2.3.5 s nizom umjesto tri brojaca)
*/

#include <stdio.h>

// Nalazimo najmanji djelitelj kojeg mozemo koristiti
int dmax(int br[], int n)
{
    while(n>2 && !br[--n]);

    return n;
}

void ispis(int br[], int n)
{
    int i, prvi=1;

    for(i=2; i<=n; i++){
        if(br[i]){
            printf("%c%d^%d", (prvi)?'\n':'*',i,br[i]); //samo da bude ljepsi ispis, moze se to i bolje
            prvi=0;
        }
    }
}

int part_um(int x,int br[], int n)
{
    int d, cnt=0;

    if(x==1){
        ispis(br,n);
        return 1;
    }

    for(d=dmax(br,n); d<=x; d++){
        if(x%d==0){
            br[d]++;
            cnt+=part_um(x/d,br,n);
            br[d]--; //ovo je kljucno, inace ne bi radilo!
        }
    }

    return cnt;
}

int main(void)
{
    int br[100]={0};

    printf("\nBroj rastava je %d.\n", part_um(28,br,28));

    return 0;
}
